using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Text;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;


namespace CSSaver3
{
    class PaintThread
    {
        IntPtr parentWindow;

        private PaintThread()
        {
        }

        public PaintThread(IntPtr parent)
        {
            parentWindow = parent;
        }

        public void Run()
        {
            while (IsWindow(parentWindow) && !IsWindowVisible(parentWindow))
                Thread.Sleep(50);

            if (IsWindow(parentWindow))
            {
                //QɂP͕\摜
                Bitmap bm1 = new Bitmap(typeof(Form1), "Bitmaps.frn02.gif");
                //ߐF̎w
                bm1.MakeTransparent(Color.Black);
                //_ɕ\摜̕ϐ
                Bitmap bmCPian = null;
                //̏
                Random r = new Random();
                //ϐ̐錾
                bool bTos = true;

                RECT rc = new RECT();
                if (GetClientRect(parentWindow, ref rc))
                {
                    while (IsWindow(parentWindow) && IsWindowVisible(parentWindow))
                    {
                        using (Graphics g = Graphics.FromHwnd(parentWindow))
                        {
                            if (null != g)
                            {
                                if (bTos)
                                {
                                    //ʂŃNA
                                    g.Clear(Color.Black);//Black͓KɕύXĉ
                                    g.DrawImage(bm1, rc.Left, rc.Top, rc.Width, rc.Height);
                                }
                                else
                                {
                                    if (bmCPian != null)
                                        bmCPian.Dispose();

                                    //_ɕ\摜ϐɃZbg
                                    switch (r.Next(3))
                                    {
                                        case 0:
                                            bmCPian = new Bitmap(typeof(Form1), "Bitmaps.frn03.gif");
                                            break;
                                        case 1:
                                            bmCPian = new Bitmap(typeof(Form1), "Bitmaps.frn07.gif");
                                            break;
                                        case 2:
                                            bmCPian = new Bitmap(typeof(Form1), "Bitmaps.frn11.gif");
                                            break;                          
                                    }
                                    
                                    //vr[ʂɃ_ɉ摜\
                                    g.DrawImage(bmCPian, rc.Left, rc.Top, rc.Width, rc.Height);
                                    Application.DoEvents();
                                }

                                bTos = !bTos;
                                Thread.Sleep(500);
                                
                            }
                        }
                        Thread.Sleep(250);
                    }
                }
                //AvP[VI܂
                Application.Exit();
            }
        }

        #region WIN32 Interop
        [StructLayout(LayoutKind.Sequential)]
        private struct RECT
        {
            public int left;
            public int top;
            public int right;
            public int bottom;

            public int Left
            { get { return left; } }
            public int Top
            { get { return top; } }
            public int Right
            { get { return right; } }
            public int Bottom
            { get { return bottom; } }
            public int Width
            { get { return right - left; } }
            public int Height
            { get { return bottom - top; } }
        }

        [DllImport("user32.dll")]
        private static extern bool IsWindow(IntPtr hWnd);
        [DllImport("user32.dll")]
        private static extern bool IsWindowVisible(IntPtr hWnd);
        [DllImport("user32.dll")]
        private static extern bool GetClientRect(IntPtr hWnd, ref RECT rect);
        #endregion

    }
}
