﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.Design;


namespace CSSaver3
{
    public partial class frmOption : Form
    {
        
        public frmOption()
        {
            InitializeComponent();
        }

        private void ｆｒｍOption_Load(object sender, EventArgs e)
        {
            //ラベルの設定
            // バージョン名（AssemblyInformationalVersion属性）を取得
            string appVersion = Application.ProductVersion;
            // 製品名（AssemblyProduct属性）を取得
            string appProductName = Application.ProductName;
            // 会社名（AssemblyCompany属性）を取得
            string appCompanyName = Application.CompanyName;

            //上記で取得した情報をラベルにセット
            lblProductName.Text = appProductName; ;
            lblVer.Text = "Version: " + appVersion;
            Text = appProductName + " のオプション";
            lblCampany.Text = "Company: " + appCompanyName;

            ////レジストリキーの読み出し
            Common.LoadSettings();
            trackBar1.Value = Common.Settings.intChgSpeed;
            lblSpd.Text = trackBar1.Value.ToString() + "ミリ秒";

            //コンボボックスcmbColorsに色名をセット
            cmbColors.Items.Add("Black");
            cmbColors.Items.Add("AliceBlue");
            cmbColors.Items.Add("AntiqueWhite");
            cmbColors.Items.Add("Aqua");
            cmbColors.Items.Add("Aquamarine");
            cmbColors.Items.Add("Azure");
            cmbColors.Items.Add("BlueViolet");
            cmbColors.Items.Add("LawnGreen");
            cmbColors.Items.Add("MediumBlue");
            cmbColors.Items.Add("OrangeRed");
            cmbColors.Items.Add("Yellow");
            cmbColors.Items.Add("Cyan");
            cmbColors.Items.Add("Chocolate");
            cmbColors.Items.Add("Olive");
            cmbColors.Items.Add("Red");
            //cmbColors.SelectedIndex = 0;

            cmbColors.BackColor = Common.Settings.BGColor;

        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            Common.Settings.intChgSpeed= trackBar1.Value;
            Common.Settings.BGColor = cmbColors.BackColor;
            Common.SaveSettings();
            this.Close();
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            lblSpd.Text = trackBar1.Value.ToString() +"ミリ秒";
        }

        private void cmbColors_SelectedIndexChanged(object sender, EventArgs e)
        {
            string str = cmbColors.SelectedItem.ToString();
            switch (str)
            {
                case "Black":
                    cmbColors.BackColor = Color.Black;
                    break;
                case "AliceBlue":
                    cmbColors.BackColor = Color.AliceBlue;
                    break;
                case "AntiqueWhite":
                    cmbColors.BackColor = Color.AntiqueWhite;
                    break;
                case "Aqua":
                    cmbColors.BackColor = Color.Aqua;
                    break;
                case "Aquamarine":
                    cmbColors.BackColor = Color.Aquamarine;
                    break;
                case "Azure":
                    cmbColors.BackColor = Color.Azure;
                    break;
                case "BlueViolet":
                    cmbColors.BackColor = Color.BlueViolet;
                    break;
                case "LawnGreen":
                    cmbColors.BackColor = Color.LawnGreen;
                    break;
                case "MediumBlue":
                    cmbColors.BackColor = Color.MediumBlue;
                    break;
                case "OrangeRed":
                    cmbColors.BackColor = Color.OrangeRed;
                    break;
                case "Yellow":
                    cmbColors.BackColor = Color.Yellow;
                    break;
                case "Cyan":
                    cmbColors.BackColor = Color.Cyan;
                    break;
                case "Chocolate":
                    cmbColors.BackColor = Color.Chocolate;
                    break;
                case "Olive":
                    cmbColors.BackColor = Color.Olive;
                    break;
                case "Red":
                    cmbColors.BackColor = Color.Red;
                    break;
            }
        }
   }
}